<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - The Syntax of Type Strings</TITLE>
<link href="builder_8.html" rel=Next>
<link href="builder_6.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_6.html">previous</A>, <A HREF="builder_8.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC14" HREF="builder_toc.html#TOC14">The Syntax of Type Strings</A></H2>
<P>
<A NAME="IDX21"></A>
<A NAME="IDX22"></A>
The C-like type string is built using a set of base types. 

</P>


<H3><A NAME="SEC15" HREF="builder_toc.html#TOC15">Base Types</A></H3>
<P>
<A NAME="IDX23"></A>
The allowed
base types are <CODE>void</CODE>, <CODE>char</CODE>, <CODE>short</CODE>, <CODE>int</CODE>,
<CODE>int16</CODE>, <CODE>int32</CODE>, <CODE>int64</CODE>, <CODE>long</CODE>, <CODE>unsigned</CODE>,
<CODE>unsigned16</CODE>, <CODE>unsigned32</CODE>, <CODE>unsigned64</CODE>, <CODE>float</CODE>,
<CODE>float64</CODE> and <CODE>double</CODE>.  
<A NAME="IDX24"></A>
<A NAME="IDX25"></A>
<A NAME="IDX26"></A>
<A NAME="IDX27"></A>
<A NAME="IDX28"></A>
<A NAME="IDX29"></A>
<A NAME="IDX30"></A>
<A NAME="IDX31"></A>
<A NAME="IDX32"></A>
<A NAME="IDX33"></A>
<A NAME="IDX34"></A>
<A NAME="IDX35"></A>
<A NAME="IDX36"></A>
<A NAME="IDX37"></A>
<A NAME="IDX38"></A>

</P>
<P>
The type modifers <CODE>const</CODE> and
<CODE>volatile</CODE> can be applied to any of the types.

<PRE>
      type_node * tn = block::parse_type("const int");
</PRE>

<P>
<A NAME="IDX39"></A>
<A NAME="IDX40"></A>
<A NAME="IDX41"></A>
<A NAME="IDX42"></A>

</P>
<P>
Composite types can be created for pointers, arrays, functions,
structures and unions.

</P>


<H3><A NAME="SEC16" HREF="builder_toc.html#TOC16">Pointer Types</A></H3>
<P>
<A NAME="IDX43"></A>
A pointer type is given by a `<CODE>*</CODE>' following the base type.

<PRE>
      type_node * tn = block::parse_type("const char  *");
</PRE>

<P>
<A NAME="IDX44"></A>
<A NAME="IDX45"></A>
<A NAME="IDX46"></A>

</P>


<H3><A NAME="SEC17" HREF="builder_toc.html#TOC17">Array Types</A></H3>
<P>
<A NAME="IDX47"></A>
An array type is given by specifying the dimensions
with their sizes delimited by square-brackets to the right of the base
type. For example a two dimension array (100x100) of character strings
is defined by:

<PRE>
      type_node * tn = block::parse_type("char  * [100][100]");
</PRE>

<P>
<A NAME="IDX48"></A>
<A NAME="IDX49"></A>
<A NAME="IDX50"></A>

</P>


<H3><A NAME="SEC18" HREF="builder_toc.html#TOC18">Function Types</A></H3>
<P>
<A NAME="IDX51"></A>
A function type is given by a base type followed by a list of argument types
within parentheses. For example, a function type with three
arguments (constant character string, integer, integer) that returns an
integer is defined by: 

<PRE>
      type_node * tn = block::parse_type("int (const char *, int, int)");
</PRE>

<P>
<A NAME="IDX52"></A>
<A NAME="IDX53"></A>
<A NAME="IDX54"></A>

</P>


<H3><A NAME="SEC19" HREF="builder_toc.html#TOC19">Structure and Union Types</A></H3>
<P>
<A NAME="IDX55"></A>
<A NAME="IDX56"></A>
For structure and union types, both the type of the field and the name
of the field have to be specified. The name field can be any
alpha-numeric string. For example a structure with two doubles is:

<PRE>
      type_node * tn = block::parse_type(" struct { double real;
                                                    double imag }");
</PRE>

<P>
<A NAME="IDX57"></A>
<A NAME="IDX58"></A>
<A NAME="IDX59"></A>
<A NAME="IDX60"></A>

</P>



<H3><A NAME="SEC20" HREF="builder_toc.html#TOC20">Using Existing Type Structures</A></H3>
<P>
<A NAME="IDX61"></A>
<A NAME="IDX62"></A>
Existing types can be manipulated by either giving an existing type node
as an argument to the <CODE>parse_type</CODE> call or by providing the
<EM>type id</EM> in the string. For example, 

<PRE>
        type_node * t1;
        type_node * t2;
        type_node * r;
        r = block::parse_type("%% * (%34, %%)", t1, t2);
</PRE>

<P>
<A NAME="IDX63"></A>
<A NAME="IDX64"></A>
<A NAME="IDX65"></A>
The type node <CODE>r</CODE> will be of a function type of a function that
returns a value of the type given by the type node <CODE>t1</CODE>. This function
type has two arguments; the type with id number 34 is the first argument
and the type given by type node <CODE>t2</CODE> is the second argument. 

</P>
<P>
Most of the combinations of the base types that are valid in C can be
used within the builder type system.
See section <A HREF="builder_37.html#SEC68">Defining Variables and Generating New Type Definitions</A> for exact definitions for the
<CODE>parse_type()</CODE> function.

</P>
<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_6.html">previous</A>, <A HREF="builder_8.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
